import random
import sys
import math
#build dictionary with all graphs -> classes of nodes
#f = open( "all2xtrans")
classnumbers = []

print 'Reading ', sys.argv[1]

f = open(sys.argv[1])
    
d = dict() #dictionary that stores all classes that the graphid(key) has nodes in
e = dict() #count nodes in each class

for line in f:
    if line.startswith( 'Class' ):
        classnumber = int( line.split()[1] )
        # for randomization
        classnumbers.append(classnumber)
        e[classnumber] = 0
    else:
        e[classnumber] += 1
        linesplit = line.split()
        #print 'HADDDA!!!!!!!'
        #print linesplit
        graphid = int(linesplit[0])
        if graphid in d:
            d[graphid].append(classnumber)
        else:
            d[graphid] = [classnumber]
                
f.close()

##randomize the dict
#for key in d.keys():
#    for i in xrange(len(d[key])):
#        d[key][i] = random.choice(classnumbers)

#keys = d.keys()
#keys.sort()
#for key in keys:
#    print key, d[key]
    
#now build reverse dictionary; node class -> graphs with this node class
reversedict = dict()

for gkey in d.keys():
    for nodeclass in d[gkey]:
        if nodeclass in reversedict:
            reversedict[nodeclass].append(gkey)
        else:
            reversedict[nodeclass] = [gkey]
            
            
#keys = reversedict.keys()
#keys.sort()
#for key in keys:
#    print key, reversedict[key]

def gstepval(a,b):
    return abs(a/1000 - b/1000) + abs(a%100 - b%100)

def myfunc(a,b): return a + str(b[0])+'('+str(b[1])+'), ' 

stepvalsum = 0
stepvalsumtrip = 0
stepvalsumall = 0

stepvalsums = []
stepvalsumtrips = []
stepvalsumalls = []

def mean(inputv):
    return sum(inputv)/float(len(inputv))

def stddev(inputv):
    m_ = mean(inputv)
    return math.sqrt( sum([ (x-m_)*(x-m_) for x in inputv])/float(len(inputv)) )

print 'Writing to ', sys.argv[2]
fout = open( sys.argv[2], 'w' )    
    
for graphid in d.keys():
    countdict = dict.fromkeys( d.keys(), 0 )
    for nodeclass in d[graphid]:
        for graph in set(reversedict[nodeclass]): #set makes sure we only get 1 count for graphid
            countdict[graph] += 1
    
    #now find best matches
    a = countdict.items()
    a.sort(key=lambda tup: tup[1], reverse=True)
    
    #remove sel
    itemslist = [x for x in a if x[0] != graphid and x[1] > 0] # best of all
    #itemslist = [x for x in a if x[0] != graphid and x[1] > 0][:20] # best of 20
  
    temp_ = gstepval( graphid, itemslist[0][0]  )
    #stepvalsum += temp_
    stepvalsums.append(temp_)
    
    temp_ = min([gstepval( graphid, itemslist[x][0] ) for x in xrange( min(len(itemslist),5) ) ])
    #stepvalsumtrip += temp_
    stepvalsumtrips.append( temp_ )
    
    #itemslist = itemslist[-5:]
    
    #temp_ =  min( [gstepval( graphid, itemslist[x][0] ) for x in xrange(len(itemslist)-5,len(itemslist))] )
    temp_ =  min( [gstepval( graphid, itemslist[x][0] ) for x in xrange( min(len(itemslist),20) )] )
    #stepvalsumall += temp_
    stepvalsumalls.append( temp_ )
    
    fout.write( str(graphid) + '(' + str(len(d[graphid])) + ') -- ' + reduce(myfunc, itemslist, '' ) + '\n' )
    #print 'step to best:         ', gstepval( graphid, itemslist[0][0] )
    #print 'step to best of five: ', min([gstepval( graphid, itemslist[x][0] ) for x in xrange(5)] )
    #print 'step to best of all:  ', min([gstepval( graphid, itemslist[x][0] ) for x in xrange(len(itemslist))] )
fout.write( 'Number of classes: ' + str(len(classnumbers)) +'\n')

nonemptylist = [e[x] for x in e.keys() if e[x]!=0]
fout.write(  'Number non empty classes: ' + str(len(nonemptylist))  +'\n')
fout.write(  'mean nodes in a class: ' + str(mean(nonemptylist))  +'\n')
fout.write(  'max: ' + str(max(nonemptylist)) + ' min: ' + str(min(nonemptylist))  +'\n')
fout.write(  'std dev: ' + str(stddev(nonemptylist))  +'\n')

fout.write(  'sum (number of nodes): ' + str(sum(nonemptylist))  +'\n')
#print [e[x] for x in e.keys() if e[x]!=0]
fout.write(  'avg. step distance to best match:              ' + str(mean(stepvalsums)) + ' stddev. ' + str(stddev(stepvalsums)) +'\n' )
fout.write(  'avg. min. step distance to best 5 matches:     ' + str(mean(stepvalsumtrips)) + ' stddev. ' + str(stddev(stepvalsumtrips))  +'\n')#float(stepvalsumtrip)/len(d)
fout.write(  'avg. min. step distance to best of all matches: ' + str(mean(stepvalsumalls)) + ' stddev. ' + str(stddev(stepvalsumalls)) +'\n' )#float(stepvalsumall)/len(d)

fout.close()