#pragma once

#include "SomNode.h"

#include "SomVectorFactory.h"

#include "LearningRateFunc.h"
#include "NbFunction.h"

class SelfOrganizingMap
{
public:
	SelfOrganizingMap(int size, int mapDimensions, SomVectorFactory::DataTypes *types, int inputDimensions, LearningRateFunc *lrFunc = NULL, NbFunction *nbFunc=NULL );


	void print();
	void printInfo();
	void train(std::vector<std::vector<double>> trainingData, int runs);
	
	void SelfOrganizingMap::printColorImage(const char *filename); // assumes 3dimensional color input space
	void SelfOrganizingMap::print2dImage(const char *filename, int xSize, int ySize, std::vector<std::vector<double>> trainingData); // assumes 2dimensional positional input space
	
	int getBestMatch(std::vector<double> vec);

	~SelfOrganizingMap(void);

private:
	int size;
	int totalSize;
	int mapDimensions;
	int inputDimensions;
	SomNode **nodes;

	LearningRateFunc *lrFunc;
	NbFunction *nbFunc;
};

