#include "stdafx.h"
#include "SomVector.h"

#include <iostream>


SomVector::SomVector(void)
{
}
void SomVector::addElement(VariableContinuous *var)
{
	vec.push_back(var);
}

SomVector::SomVector(const SomVector &other)
{
	for ( std::vector<VariableContinuous *>::const_iterator it = other.vec.begin(); it != other.vec.end(); ++it )
	{
		addElement( (*it)->clone() );
	}
}
	
double SomVector::distanceSquared(SomVector &other)
{
	// assume vectors same size
	// calculate squared euclidian distance
	double sum = 0;
	for (std::vector<VariableContinuous *>::iterator it = vec.begin(), it2 = other.vec.begin(); it != vec.end(); ++it, ++it2 )
	{
		sum += (*it)->difference((*it2)->getValue()) * (*it)->difference((*it2)->getValue());
	}
	return sum;
}

double SomVector::distanceSquared(std::vector<double> &other)
{
	// assume vectors same size
	// calculate squared euclidian distance
	double sum = 0;
	std::vector<double>::iterator it2 = other.begin();
	for (std::vector<VariableContinuous *>::iterator it = vec.begin(); it != vec.end(); ++it, ++it2 )
	{
		sum += (*it)->difference( *it2 ) * (*it)->difference( *it2 );
	}
	return sum;
}

void SomVector::moveTowards(std::vector<double> &other, double alpha)
{
	// assume vectors same size
	std::vector<double>::iterator it2 = other.begin();
	for (std::vector<VariableContinuous *>::iterator it = vec.begin(); it != vec.end(); ++it, ++it2 )
	{
		(*it)->setValue( (*it)->getValue() + (*it)->difference( *it2 ) * alpha );
	}
}
void SomVector::moveTowards(SomVector &other, double alpha)
{
	// assume vectors same size
	
	for (std::vector<VariableContinuous *>::iterator it = vec.begin(), it2 = other.vec.begin(); it != vec.end(); ++it, ++it2 )
	{
		(*it)->setValue( (*it)->getValue() + (*it)->difference( (*it2)->getValue() ) * alpha );
	}
}

void SomVector::print()
{
	for (std::vector<VariableContinuous *>::iterator it = vec.begin(); it != vec.end(); ++it )
	{
		std::cout << (*it)->getValue() << " ";
	}
}

SomVector::~SomVector(void)
{
	
	for (std::vector<VariableContinuous *>::iterator it = vec.begin(); it != vec.end(); ++it )
		delete *it;
	
}
