#pragma once

#include <vector>
#include "VariableContinuous.h"

class SomVector 
{
public:

	SomVector(void);
	
	SomVector(const SomVector &); // copy constructor

	void addElement(VariableContinuous *var);
	void setElements(SomVector &other);

	double distance(SomVector &other) { return sqrt(distanceSquared(other)); }
	double distanceSquared(SomVector &other);
	double distanceSquared(std::vector<double> &other);
	void moveTowards(std::vector<double> &other, double alpha);
	void moveTowards(SomVector &other, double alpha);
	
	VariableContinuous *element(int index){return vec.at(index); }

	void print();

	~SomVector(void);
private:
	std::vector<VariableContinuous *> vec;
};

