#include "stdafx.h"
#include "SomVectorFactory.h"

#include "VariableCircular.h"
#include "VariableContinuous.h"

SomVectorFactory::SomVectorFactory(void)
{
}
SomVector *SomVectorFactory::createVector(DataTypes *types, int dimensions)
{
	SomVector *vec = new SomVector();
	for ( int i = 0; i < dimensions; i++ )
	{
		switch (types[i])
		{
			case CONTINUOUS:
				vec->addElement( new VariableContinuous( (double)rand()/RAND_MAX ) );
				break;
			case CIRCULAR_DEGREE:
				vec->addElement( new VariableCircular( (double)rand()/RAND_MAX * 360, 360 ) );
				break;
			case CIRCULAR_NORMALIZED:
				vec->addElement( new VariableCircular( (double)rand()/RAND_MAX, 1 ) );
				break;
			default:
				break;
		}
	}
	return vec;
}

SomVectorFactory::~SomVectorFactory(void)
{
}
