// som2.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"

#include "VariableContinuous.h"
#include "VariableCircular.h"
#include "SomVector.h"
#include "SomNode.h"
#include "SelfOrganizingMap.h"
#include "SomVectorFactory.h"

#include "SimpleLearningRateFunc.h"
#include "SimpleNBFunc.h"

#include <iostream>
#include <fstream>
#include <sstream>

#include <string>

using namespace std;

vector<std::string> splitString(const char in[])
{
    std::istringstream iss(in);
    std::istream_iterator<std::string> first(iss), last;

    std::vector<std::string> parts;
    std::copy(first, last, std::back_inserter(parts));
    return parts;
}

void test1()
{
	if ( true )
	{

		VariableContinuous item1(2);
		VariableContinuous item2(-3);
		VariableContinuous item3(2);

		cout << "item1: " << item1.getValue() << endl;
		cout << "item2: " << item2.getValue() << endl;
		cout << "item3: " << item3.getValue() << endl;
		cout << "item1.difference(item2): " << item1.difference(item2.getValue()) << endl;
		cout << "item2.difference(item1): " << item2.difference(item1.getValue()) << endl;
		cout << "item1.difference(item3): " << item1.difference(item3.getValue()) << endl;

		VariableCircular itemc1(60,360);
		VariableCircular itemc2(-30,360);
		VariableCircular itemc3(360,360);
		cout << "itemc1: " << itemc1.getValue() << endl;
		cout << "itemc2: " << itemc2.getValue() << endl;
		cout << "itemc2: " << itemc3.getValue() << endl;
		cout << "itemc1.difference(itemc2): " << itemc1.difference(itemc2.getValue()) << endl;
		cout << "itemc1.distance(itemc2): " << itemc1.distance(itemc2.getValue()) << endl;
		cout << "itemc2.difference(itemc1): " << itemc2.difference(itemc1.getValue()) << endl;
		cout << "itemc1.difference(itemc1): " << itemc1.difference(itemc1.getValue()) << endl;
		cout << "itemc3.difference(itemc3): " << itemc3.difference(itemc3.getValue()) << endl;
		cout << "itemc1.distance(itemc2): " << itemc1.distance(itemc2.getValue()) << endl;
		cout << "itemc2.distance(itemc1): " << itemc2.distance(itemc1) << endl;
	
		cout << "polymorphism:" << endl;
		VariableContinuous *itemc4 = new VariableCircular(10, 360);
		VariableContinuous *itemc5 = new VariableCircular(-10, 360);
		cout << "itemc4->distance(itemc5): " << itemc4->distance(*itemc5) << endl;
		delete itemc4;
		delete itemc5;

		SomVector v1, v2;
		v1.addElement(new VariableContinuous(10));
		v1.addElement(new  VariableCircular(10,360));
		v1.addElement(new VariableContinuous(20));
	
		v2.addElement(new VariableContinuous(1));
		v2.addElement(new VariableCircular(350,360));
		v2.addElement(new VariableContinuous(200));
		cout << "v1.print(): "; v1.print();
		cout << "v2.print(): "; v2.print();
		cout << "v1.distance(v2): " << v1.distance(v2) << endl;
		cout << "v1.distanceSquared(v2): " << v1.distanceSquared(v2) << endl;
		v1.moveTowards(v2,0.75);
		cout << "v1.distance(v2): " << v1.distance(v2) << endl;
		cout << "v1.print(): "; v1.print();
		cout << "v2.print(): "; v2.print();

		double pos1[] = {0, 0};
		double pos2[] = {2, 2};
		SomNode node1(pos1,2);
		SomNode node2(pos2,2);
	
		cout << "node1.distanceSquared(node2): " << node1.distanceSquared(node2) << endl;
	}	
	/*
	SomVectorFactory::DataTypes types[3] = {
		SomVectorFactory::DataTypes::CONTINUOUS,
		SomVectorFactory::DataTypes::CONTINUOUS,
		SomVectorFactory::DataTypes::CONTINUOUS
	};*/
	SomVectorFactory::DataTypes types[3] = {
		SomVectorFactory::DataTypes::CONTINUOUS,
		SomVectorFactory::DataTypes::CONTINUOUS,
		SomVectorFactory::DataTypes::CONTINUOUS
	};

	int runs = 8;
	int netSize = 256;
	
	SelfOrganizingMap mySom(
		netSize,2,types,3, 
		new SimpleLearningRateFunc(0.25, 0.0 ), 
		new SimpleNBFunc( 256, -32 )
		//new SimpleNBFunc( netSize-1, -(netSize-1)/(double)runs )
		);

	//mySom.print();
	
	std::vector<std::vector<double>> trainingData;
	for ( int i = 0; i < 64; i++ )
	{
		std::vector<double> vtemp;
		//double val = (double)rand()/RAND_MAX;
		
		/*
		vtemp.addElement( new VariableContinuous((double)i/15));
		vtemp.addElement( new VariableContinuous((double)i/15));
		vtemp.addElement( new VariableContinuous((double)i/15));
		*/
		/*
		vtemp.addElement( new VariableCircular( (double)i/128, 1 ));
		vtemp.addElement( new VariableCircular( (double)i/128, 1  ));
		vtemp.addElement( new VariableCircular( (double)i/128, 1 ) );
		*/
		
		vtemp.push_back( (double)rand()/RAND_MAX );
		vtemp.push_back( (double)rand()/RAND_MAX );
		vtemp.push_back( (double)rand()/RAND_MAX );

		

		trainingData.push_back(vtemp);
	}
	
	/*
	std::cout << "Training data:" << std::endl;
	for ( std::vector<SomVector>::iterator it = trainingData.begin(); it != trainingData.end(); ++it )
	{
		std::cout << " - "; it->print(); std::cout << std::endl;
	}
	*/
	mySom.printColorImage("0.tga");

	mySom.train( trainingData, runs );
	//cout << "After training: " << endl;
	//mySom.print();

	mySom.printColorImage("1.tga");
}

void test2()
{
	/*
	SomVectorFactory::DataTypes types[3] = {
		SomVectorFactory::DataTypes::CONTINUOUS,
		SomVectorFactory::DataTypes::CONTINUOUS,
		SomVectorFactory::DataTypes::CONTINUOUS
	};*/
	SomVectorFactory::DataTypes types[3] = {
		SomVectorFactory::DataTypes::CONTINUOUS,
		SomVectorFactory::DataTypes::CONTINUOUS,
		SomVectorFactory::DataTypes::CONTINUOUS
	};

	int runs = 100;
	int netSize = 32;
	
	SelfOrganizingMap mySom(
		netSize,2,types,3, 
		new SimpleLearningRateFunc(1.0, -1.0/runs ), 
		new SimpleNBFunc( netSize*1.414, -(double)netSize*1.414/(double)runs )
		//new SimpleNBFunc( netSize-1, -(netSize-1)/(double)runs )
		);

	//mySom.print();
	
	std::vector<std::vector<double>> trainingData;
	
	//for ( long int i = 0; i < 8*8*8; ++i )
	//{
		//std::vector<double> vtemp;
		//double val = (double)rand()/RAND_MAX;
		
		/*
		vtemp.addElement( new VariableContinuous((double)i/15));
		vtemp.addElement( new VariableContinuous((double)i/15));
		vtemp.addElement( new VariableContinuous((double)i/15));
		*/
		/*
		vtemp.addElement( new VariableCircular( (double)i/128, 1 ));
		vtemp.addElement( new VariableCircular( (double)i/128, 1  ));
		vtemp.addElement( new VariableCircular( (double)i/128, 1 ) );
		*/
		
		//vtemp.push_back( (double)rand()/RAND_MAX );
		//vtemp.push_back( (double)rand()/RAND_MAX );
		//vtemp.push_back( (double)rand()/RAND_MAX );
		
		//vtemp.push_back( (i%8) / 8.0 );
		//vtemp.push_back( ((i/8)%8) / 8.0);
		//vtemp.push_back( ((i/8/8)%16) / 8.0 );

		//std::cout << vtemp[0] << ",\t" << vtemp[1] << ",\t" << vtemp[2] << std::endl;

		//trainingData.push_back(vtemp);
	//}
	std::vector<double> vtemp;
	vtemp.push_back( 1.0 );
	vtemp.push_back( 0.0 );
	vtemp.push_back( 0.0 );
	trainingData.push_back(vtemp);
	
	vtemp[0] = 1.0;
	vtemp[1] = 0.5;
	vtemp[2] = 0.0;
	trainingData.push_back(vtemp);
	
	vtemp[0] = 1.0;
	vtemp[1] = 1.0;
	vtemp[2] = 0.0;
	trainingData.push_back(vtemp);

	vtemp[0] = 0.0;
	vtemp[1] = 1.0;
	vtemp[2] = 0.0;
	trainingData.push_back(vtemp);
	vtemp[0] = 0.0;
	vtemp[1] = 0.0;
	vtemp[2] = 1.0;
	trainingData.push_back(vtemp);
	vtemp[0] = 75.0/255;
	vtemp[1] = 0.0;
	vtemp[2] = 130./255;
	trainingData.push_back(vtemp);
	vtemp[0] = 143.0/255;
	vtemp[1] = 0.0;
	vtemp[2] = 1.0;
	trainingData.push_back(vtemp);
	/*
	std::cout << "Training data:" << std::endl;
	for ( std::vector<SomVector>::iterator it = trainingData.begin(); it != trainingData.end(); ++it )
	{
		std::cout << " - "; it->print(); std::cout << std::endl;
	}
	*/
	mySom.printColorImage("0.tga");

	mySom.train( trainingData, runs );
	//cout << "After training: " << endl;
	//mySom.print();

	mySom.printColorImage("1.tga");
}

enum VariableTypes { CIRCULAR360, CIRCULAR_NORMALIZED, CONTINUOUS, IGNORE };

int _tmain(int argc, _TCHAR* argv[])
{
	//test1();

	//test2();
	//return 0;

	if ( argc != 6 ){
		std::cerr << "Use: " << argv[0] << " input output runs size dimensions" << endl;
		return 0;
	}

	ifstream myfile;
	string line;
	myfile.open(argv[1], ios::in);
	SomVectorFactory::DataTypes *somTypes = NULL;
	int numSomTypes = 0;

	std::vector<std::vector<double>> trainingData;
	

	if (myfile.is_open())
	{
		
		cout << "---\nReading file: "; 
		std::wcout << argv[1];
		std::cout << endl << endl;
		vector<VariableTypes> types;
		// first line is number of variables
		getline (myfile,line);
		int numVars = atoi( line.c_str() );

		cout << numVars << " variables: " << endl;
		int activeVariables = 0;
		// build types table
		types.push_back(VariableTypes::IGNORE); // ignore the id variable
		for ( int i = 0; i < numVars; ++i )
		{
			getline (myfile,line);
			//cout << line << endl;
		
			vector<std::string> parts = splitString(line.c_str());
			
			if ( atoi( parts[0].c_str() ) == 0 )// inactive
				types.push_back(VariableTypes::IGNORE);
			else {
				++activeVariables;
				if ( atoi( parts[1].c_str() ) == 1 )
				{
					types.push_back(VariableTypes::CONTINUOUS);
				}
				else if ( atoi( parts[1].c_str() ) == 4 )
				{
					types.push_back(VariableTypes::CIRCULAR360);
				}
				else {
					cout << "Unsupported type (will be skipped): " << parts[1] << endl;
					types.push_back(VariableTypes::IGNORE);
					--activeVariables;
				}
			}
		}

		// build types table for SOM constructor
		cout << "active: " << activeVariables << endl;
		numSomTypes = activeVariables;
		somTypes = new SomVectorFactory::DataTypes[numSomTypes];
		
		int typesIndex = 0;
		for ( vector<VariableTypes>::iterator it = types.begin(); it != types.end(); ++it )
		{
			if ( *it == VariableTypes::CIRCULAR360 )
				//typesIndex++;
				somTypes[typesIndex++] = SomVectorFactory::DataTypes::CIRCULAR_DEGREE;
			else if ( *it == VariableTypes::CONTINUOUS )
				//typesIndex++;
				somTypes[typesIndex++] = SomVectorFactory::DataTypes::CONTINUOUS;
			else if ( *it == VariableTypes::CIRCULAR_NORMALIZED )
				//typesIndex++;
				somTypes[typesIndex++] = SomVectorFactory::DataTypes::CIRCULAR_NORMALIZED;
		}
		
		
		cout << "Number of variables: " << types.size() << " Recognized types: " << activeVariables << endl;
	
		int varCounter = 0;
		bool run = true;
		
		std::vector<double> vTemp;
		getline (myfile,line);
		while ( myfile.good() )
		{
			
			
			vector<std::string> parts = splitString( line.c_str() );
			
			
			int curIndex = varCounter % types.size();
			
				
			if ( curIndex == 0 && atoi( parts[0].c_str() ) == 0 ){
				cout << "breaking at line:" << line << " varCounter:" << varCounter  << "types.size:" << types.size() << " curIndex: " << curIndex << endl;
				break;//run = false;
			}
			else {
				// continue reading
				
				for ( vector<std::string>::iterator it = parts.begin(); it != parts.end(); ++it )
				{
					curIndex = varCounter % types.size();
					//cout << varCounter << " ( " << curIndex << " ) = " << *it << endl;
					
					// only add usable types, skip id and discreete
					if ( types.at(curIndex) == VariableTypes::CIRCULAR360 )
						vTemp.push_back( atof(it->c_str() ) );
					else if ( types.at(curIndex) == VariableTypes::CONTINUOUS )
						vTemp.push_back( atof(it->c_str() ) );
					else if ( types.at(curIndex) == VariableTypes::CIRCULAR_NORMALIZED )
						vTemp.push_back( atof(it->c_str() ) );

					//if ( curIndex == activeVariables-1 )
					if ( curIndex == types.size()-1 )
					{
						//std::cout<<"pushing back vec of size " << vTemp.size() << std::endl;
						trainingData.push_back(vTemp);
						vTemp.clear();
					}
					varCounter++;
				}
			}
			getline (myfile,line);
		}	

		myfile.close();
	}

	std::cout<<"Training data reading done..." << std::endl;
	std::cout << "Training set size: " << trainingData.size() << std::endl;
	std::cout << "First training vector size: " << trainingData.at(0).size() << std::endl;
	//std::cout << "Second training vector size: " << trainingData.at(1).size() << std::endl;

	// normalize training data
	
	double *minVals = new double[ numSomTypes ];
	double *maxVals = new double[ numSomTypes ];

	// initialize values
	int _iCounter = 0;
	for ( vector<double>::iterator it2 = trainingData.begin()->begin(); it2 != trainingData.begin()->end(); ++it2 )
	{
		minVals[_iCounter] = maxVals[_iCounter] = *it2;
		++_iCounter;
	}
		
	//std::cout<<"debug 1" << std::endl;

	// find all min/max values
	//std::cout << "in training vector: " << std::endl;
	for ( vector<vector<double>>::iterator it = trainingData.begin(), itend = trainingData.end(); it != itend; ++ it )
	{
		int _iCounter = 0;
		for ( vector<double>::iterator it2 = it->begin(); it2 != it->end(); ++it2 )
		{
			//std::cout << *it2 << ", ";
			
			if ( minVals[_iCounter] > *it2 )
				minVals[_iCounter] = *it2;
			else if ( maxVals[_iCounter] < *it2 )
				maxVals[_iCounter] = *it2;

			++_iCounter;
		}
		//std::cout << endl;
	}
	
	//std::cout<<"debug 2 " << std::endl;

	// now normalize
	for ( vector<vector<double>>::iterator it = trainingData.begin(), itend = trainingData.end(); it != itend; ++ it )
	{
		int _iCounter = 0;
		for ( vector<double>::iterator it2 = it->begin(); it2 != it->end(); ++it2 )
		{
			if ( somTypes[_iCounter] == SomVectorFactory::DataTypes::CIRCULAR_DEGREE )
				*it2 = *it2 / 360.0;
			else
				*it2 = (*it2 - minVals[_iCounter]) / (maxVals[_iCounter]-minVals[_iCounter]);

			std::cout << *it2 << " ";

			++_iCounter;
		}
	}
	
	//std::cout<<"debug 3" << std::endl;

	// now swap circular degrees type into circular normalized
	for ( int i = 0; i < numSomTypes; ++i )
	{
		if ( somTypes[i] == SomVectorFactory::DataTypes::CIRCULAR_DEGREE )
			somTypes[i] = SomVectorFactory::DataTypes::CIRCULAR_NORMALIZED;
	}
	

	std::cout<<"Normalizing of training data done..." << std::endl;

	// now create som!
	cout << "Number of training vectors: " << trainingData.size() << endl;

	//SelfOrganizingMap mySom();
	int runs = _tstoi(argv[3]);
	int netSize = _tstoi(argv[4]);
	int netDimensions= _tstoi(argv[5]);

	double nbSizeStart = sqrt(pow(netSize,2)*netDimensions);
	//double nbSizeStart = 2;
	double nbSizeStep = -nbSizeStart/runs;

	SelfOrganizingMap mySom(
		netSize,netDimensions,somTypes,numSomTypes, 
		//new SimpleLearningRateFunc(0.0, 0.0 ), 
		new SimpleLearningRateFunc(0.25, -0.25/runs ), 
		new SimpleNBFunc( nbSizeStart, nbSizeStep )
		//new SimpleNBFunc( netSize-1, -(netSize-1)/(double)runs )
		);
	
	cout << "SOM created: " << endl;
	mySom.printInfo();

	cout << "Starting training" << endl;
	mySom.train(trainingData,runs);

	cout << "training done. results:" << endl;

	// now classify each input vector and store to table
	std::vector<std::vector<int>> classificationResults(pow(netSize,netDimensions));

	int idCounter = 1;
	for ( vector<vector<double>>::iterator it = trainingData.begin(); it != trainingData.end(); ++it )
	{
		int bestNode = mySom.getBestMatch(*it);
		classificationResults.at(bestNode).push_back(idCounter++);
	}


	// now print results table
	ofstream outputFile;
	outputFile.open (argv[2]);
	cout << "Writing results to file:";
	std::wcout << argv[2];
	cout << endl;
	if ( outputFile.is_open() )
	{
		idCounter = 1;
		for ( std::vector<std::vector<int>>::iterator it = classificationResults.begin(); it != classificationResults.end(); ++it )
		{
			outputFile << "Class " << idCounter++ << endl;
			for ( std::vector<int>::iterator it2 = (*it).begin(); it2 != (*it).end(); ++it2 )
			{
				outputFile << *it2 << " ";
			}
			outputFile << endl;
		}
		outputFile.close();
	}

	//cout << "Writing image: \"exout.tga\"";
	//mySom.print2dImage("exout.tga", 256, 256, trainingData);

	delete [] somTypes;
	return 0;
}

