// som2.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"

#include "VariableContinuous.h"
#include "VariableCircular.h"
#include "SomVector.h"
#include "SomNode.h"
#include "SelfOrganizingMap.h"
#include "SomVectorFactory.h"

#include "SimpleLearningRateFunc.h"
#include "SimpleNBFunc.h"

#include <iostream>

using namespace std;

int _tmain(int argc, _TCHAR* argv[])
{
	if ( false )
	{

		VariableContinuous item1(2);
		VariableContinuous item2(-3);
		VariableContinuous item3(2);

		cout << "item1: " << item1.getValue() << endl;
		cout << "item2: " << item2.getValue() << endl;
		cout << "item3: " << item3.getValue() << endl;
		cout << "item1.difference(item2): " << item1.difference(item2) << endl;
		cout << "item2.difference(item1): " << item2.difference(item1) << endl;
		cout << "item1.difference(item3): " << item1.difference(item3) << endl;

		VariableCircular itemc1(60,360);
		VariableCircular itemc2(-30,360);
		VariableCircular itemc3(360,360);
		cout << "itemc1: " << itemc1.getValue() << endl;
		cout << "itemc2: " << itemc2.getValue() << endl;
		cout << "itemc2: " << itemc3.getValue() << endl;
		cout << "itemc1.difference(itemc2): " << itemc1.difference(itemc2) << endl;
		cout << "itemc1.distance(itemc2): " << itemc1.distance(itemc2) << endl;
		cout << "itemc2.difference(itemc1): " << itemc2.difference(itemc1) << endl;
		cout << "itemc1.difference(itemc1): " << itemc1.difference(itemc1) << endl;
		cout << "itemc3.difference(itemc3): " << itemc3.difference(itemc3) << endl;
		cout << "itemc1.distance(itemc2): " << itemc1.distance(itemc2) << endl;
		cout << "itemc2.distance(itemc1): " << itemc2.distance(itemc1) << endl;
	
		cout << "polymorphism:" << endl;
		VariableContinuous *itemc4 = new VariableCircular(10, 360);
		VariableContinuous *itemc5 = new VariableCircular(-10, 360);
		cout << "itemc4->distance(itemc5): " << itemc4->distance(*itemc5) << endl;
		delete itemc4;
		delete itemc5;

		SomVector v1, v2;
		v1.addElement(new VariableContinuous(10));
		v1.addElement(new  VariableCircular(10,360));
		v1.addElement(new VariableContinuous(20));
	
		v2.addElement(new VariableContinuous(1));
		v2.addElement(new VariableCircular(350,360));
		v2.addElement(new VariableContinuous(200));
		cout << "v1.print(): "; v1.print();
		cout << "v2.print(): "; v2.print();
		cout << "v1.distance(v2): " << v1.distance(v2) << endl;
		cout << "v1.distanceSquared(v2): " << v1.distanceSquared(v2) << endl;
		v1.moveTowards(v2,0.75);
		cout << "v1.distance(v2): " << v1.distance(v2) << endl;
		cout << "v1.print(): "; v1.print();
		cout << "v2.print(): "; v2.print();

		double pos1[] = {0, 0};
		double pos2[] = {2, 2};
		SomNode node1(pos1,2);
		SomNode node2(pos2,2);
	
		cout << "node1.distanceSquared(node2): " << node1.distanceSquared(node2) << endl;
	}	
	/*
	SomVectorFactory::DataTypes types[3] = {
		SomVectorFactory::DataTypes::CONTINUOUS,
		SomVectorFactory::DataTypes::CONTINUOUS,
		SomVectorFactory::DataTypes::CONTINUOUS
	};*/
	SomVectorFactory::DataTypes types[3] = {
		SomVectorFactory::DataTypes::CONTINUOUS,
		SomVectorFactory::DataTypes::CIRCULAR_NORMALIZED,
		SomVectorFactory::DataTypes::CONTINUOUS
	};

	int runs = 64;
	int netSize = 256;
	
	SelfOrganizingMap mySom(
		netSize,2,types,3, 
		new SimpleLearningRateFunc(0.25, 0.0 ), 
		new SimpleNBFunc( 256, -4 )
		//new SimpleNBFunc( netSize-1, -(netSize-1)/(double)runs )
		);

	//mySom.print();
	
	std::vector<SomVector> trainingData;
	for ( int i = 0; i < 64; i++ )
	{
		SomVector vtemp;
		//double val = (double)rand()/RAND_MAX;
		
		/*
		vtemp.addElement( new VariableContinuous((double)i/15));
		vtemp.addElement( new VariableContinuous((double)i/15));
		vtemp.addElement( new VariableContinuous((double)i/15));
		*/
		/*
		vtemp.addElement( new VariableCircular( (double)i/128, 1 ));
		vtemp.addElement( new VariableCircular( (double)i/128, 1  ));
		vtemp.addElement( new VariableCircular( (double)i/128, 1 ) );
		*/
		
		vtemp.addElement( new VariableCircular( (double)rand()/RAND_MAX, 1 ) );
		vtemp.addElement( new VariableCircular( (double)rand()/RAND_MAX, 1 ) );
		vtemp.addElement( new VariableCircular( (double)rand()/RAND_MAX, 1 ) );
		
		trainingData.push_back(vtemp);
	}
	
	/*
	std::cout << "Training data:" << std::endl;
	for ( std::vector<SomVector>::iterator it = trainingData.begin(); it != trainingData.end(); ++it )
	{
		std::cout << " - "; it->print(); std::cout << std::endl;
	}
	*/
	mySom.printImage("0.tga");

	mySom.train( trainingData, runs );
	//cout << "After training: " << endl;
	//mySom.print();

	mySom.printImage("1.tga");
	return 0;
}

